if(storage.blob.get('recentRangeActions') == null) { storage.blob.set('recentRangeActions', []); }
if(storage.blob.get('beaconQueue') == null) { storage.blob.set('beaconQueue', []); }
if(typeof window.queueWaiting == "undefined") { window.queueWaiting = false; }
window.beaconQueueBusy = false;

var beacons = {
  initialize: function() {},
  setup_beacons: function() {
    try { beacons.unregister_regions(); }
    catch (e) { storage.clear('beacon_regions'); }
    beacons.load_regions();
  },

  load_regions: function() {
    $.ajax({
        url: helper.apiEndpointV1("beacon_regions"),
        type: "get",
        dataType: "json",
        success: function(data) {
          beacons.beacon_region_list = data;

          try {
            beacons.start_region_monitoring();
            // Store for de-registering, but only if we successfully begin monitoring
            storage.set('beacon_regions', JSON.stringify(beacons.beacon_region_list));
          }
          catch (e) {}

        },
        error: function(data) {
        }
    });
  },

  start_region_monitoring: function() {
    // required in iOS 8+
    // cordova.plugins.locationManager.requestAlwaysAuthorization();

    for (var beacon_ix in beacons.beacon_region_list) {
      var this_region = beacons.beacon_region_list[beacon_ix];
      var beaconRegion = beacons.get_beacon_region(this_region);

      if (this_region.active) {
        var delegate = new cordova.plugins.locationManager.Delegate();

        delegate.didDetermineStateForRegion = function (pluginResult) {
          cordova.plugins.locationManager.appendToDeviceLog('[DOM] didDetermineStateForRegion: ' + JSON.stringify(pluginResult));

          cordova.plugins.locationManager.appendToDeviceLog('HERP DERP DERP');
        };

        delegate.didStartMonitoringForRegion = function (pluginResult) {
          helper.log(pluginResult, 'didStartMonitoringForRegion');
        };

        delegate.didRangeBeaconsInRegion =  function (pluginResult) {
          if (pluginResult.beacons.length > 0) {
            helper.log(pluginResult, '[LOG] didRangeBeaconsInRegion');

            for (var i in pluginResult.beacons) {
              pluginResult.beacons[i].seen_at = new Date().toISOString();
            };

            beacons.store_range_data(pluginResult.region, pluginResult.beacons);
          }
        };

        delegate.didEnterRegion = function(pluginResult) {
          cordova.plugins.locationManager.appendToDeviceLog('[DOM] didEnterRegion: ' + JSON.stringify(pluginResult));
          beacons.store_region_action('enter', pluginResult.region.identifier);
        };

        delegate.didExitRegion = function(pluginResult) {
          cordova.plugins.locationManager.appendToDeviceLog('[DOM] didExitRegion: ' + JSON.stringify(pluginResult));
          beacons.store_region_action('exit', pluginResult.region.identifier);
        };

        cordova.plugins.locationManager.setDelegate(delegate);

        // Monitor the region
        cordova.plugins.locationManager.startMonitoringForRegion(beaconRegion).
          fail(console.error).
          done();

        // Range the beacon
        cordova.plugins.locationManager.startRangingBeaconsInRegion(beaconRegion).
          fail(console.error).
          done();
      } else {
        // Un-monitor the region
        cordova.plugins.locationManager.stopMonitoringForRegion(beaconRegion).
          fail(console.error).
          done();

        // Un-range the beacon
        cordova.plugins.locationManager.stopRangingBeaconsInRegion(beaconRegion).
          fail(console.error).
          done();
      }
    }
  },

  send_range_action: function(currentQueue) {
    user_id = helper.user_id();

    helper.log('SEND RANGE ACTION FUNCTION');

    if(Object.keys(currentQueue).length > 0 && !window.beaconQueueBusy){
      window.beaconQueueBusy = true;

      storage.blob.set('beaconQueue', []);

      helper.log(currentQueue, 'CURRENT QUEUE');

      tempQueue = [];

      if(user_id) {
        $.ajax({
          url: helper.apiEndpointV1("beacon_range_action"),
          type: "POST",
          dataType: "json",
          accepts: 'text/plain',
          timeout: 10000,
          data: {
            user_id: helper.user_id(),
            beacons: currentQueue,
          },
          statusCode: {
            200: function(data){
              helper.log(data, 'FUNCTION SUCCESS');

              if(window.queueWaiting) {
                beacons.send_range_action(currentQueue);
                window.queueWaiting = false;
              }
            },
            404: function(data) {
              helper.log(data, "404 ERROR");
              $.each(currentQueue, function(index, value){
                tempQueue.push(value);
              });
              current = storage.blob.get('beaconQueue');
              update = current.concat(tempQueue);
              storage.blob.set('beaconQueue', update);
            },
            500: function(data){
              helper.log(data, "500 ERROR");
              $.each(currentQueue, function(index, value){
                tempQueue.push(value);
              });
              current = storage.blob.get('beaconQueue');
              update = current.concat(tempQueue);
              storage.blob.set('beaconQueue', update);
            }
          },
          complete: function(){
            setTimeout(function(){
              window.beaconQueueBusy = false;
              helper.log('FUNCTION COMPLETE');
            }, 500);
          }
        });
      }
    }
    else if(window.beaconQueueBusy && Object.keys(currentQueue).length > 0) {
      // window.queueWaiting = true;
    }
  },

  store_range_data: function(region, beacons_seen) {
    user_id = helper.user_id();
    if(user_id) {

      offset = 10;

      $.each(beacons_seen, function(index, beacon){
        key = beacon.uuid+beacon.major+beacon.minor+helper.timestamp(offset);

        recentRangeActions = storage.blob.get('recentRangeActions');
        beaconQueue = storage.blob.get('beaconQueue');

        if(!helper.isInArray(key, recentRangeActions)) {
          recentRangeActions.unshift(key);
          storage.blob.set('recentRangeActions', recentRangeActions);

          if(storage.blob.get('recentRangeActions').length >= 500) {
            helper.log(storage.blob.get('recentRangeActions').length, 'THIS IS GETTING OUT OF HAND');
            storage.blob.set('recentRangeActions', storage.blob.get('recentRangeActions').slice(0, 10));
          }
          else { helper.log(storage.blob.get('recentRangeActions').length, 'THIS IS MANAGABLE'); }

          if(storage.blob.get('beaconQueue').length < 2500) {
            beacon.region = region.identifier;
            beacon.key = key;

            beaconQueue.push(beacon);
            storage.blob.set('beaconQueue', beaconQueue);
            helper.log('Its there now!');
          }

          helper.log(helper.check_queue_size(), "THE QUEUE IS THIS MANY KB");
        }
      });

      helper.beaconQueueSender();
    }
  },


  store_region_action: function(action_type, region_id) {
    cordova.plugins.locationManager.appendToDeviceLog('[DOM] ABOUT TO AJAX: ' + action_type + " " + helper.apiEndpointV1("beacon_region_action", region_id));
    user_id = helper.user_id();

    helper.log(["REGION ID: ", region_id, "ACTION TYPE: ", action_type]);

    if(user_id) {
      $.ajax({
        url: helper.apiEndpointV1("beacon_region_action", region_id),
        type: "POST",
        dataType: "json",
        data: {
          user_id: helper.user_id(),
          action_type: action_type
        },
        success: function(data) {},
        error: function(data) {}
      });
    }
  },

  get_beacon_region: function(beacon_hash) {
    var major = beacon_hash.major ? beacon_hash.major : undefined;
    var minor = beacon_hash.minor ? beacon_hash.minor : undefined;
    var beaconRegion = new cordova.plugins.locationManager.BeaconRegion(
        beacon_hash.id.toString(), beacon_hash.uuid, major, minor);

    return beaconRegion;
  },

  unregister_regions: function() {
    beacon_regions = JSON.parse(storage.get('beacon_regions'));

    if (beacon_regions) {
      for (var beacon_ix in beacon_regions) {
        var beaconRegion = beacons.get_beacon_region(beacon_regions[beacon_ix]);

        // Un-monitor the region
        cordova.plugins.locationManager.stopMonitoringForRegion(beaconRegion).
          fail(console.error).
          done();

        // Un-range the beacon
        cordova.plugins.locationManager.stopRangingBeaconsInRegion(beaconRegion).
          fail(console.error).
          done();
      }
    }
  }
};