app.ViewModels.footer = function(data, state) {
	var self = this;

	self.visible = ko.observable(false);
	self.navigation = ko.observable(false);
	self.buttons = ko.observableArray();

	self.activate_page = function(name) {
		ko.utils.arrayForEach(self.buttons(), function (button) {
			button.active(false);

			if(button.target == name) {
				button.active(true);
			}
		});
	}

	/**
	 *	Load the footer with button data. Some day maybe this comes from a remote source.
	 */
	data.buttons = [
		{
			'title': 'Events',
			'target': 'upcoming'
		},
		{
			'title': 'Earn Points',
			'target': 'points'
		},
		{
			'title': 'Prize Store',
			'target': 'prizes'
		},
		{
			'title': 'Settings',
			'target': 'settings'
		}
	];

	for(var i in data.buttons) {
		self.buttons.push(new app.ViewModels.footer_buttons(data.buttons[i], state));
	}


    // Seed the footer with needed data from the site_blob
    self.seed = function(data) {
        // helper.log(ad);
    }

	return self;
}

app.ViewModels.footer_buttons = function(data, state) {
	var self = this;

	self.title = data.title;
	self.target = data.target;
	self.active = ko.observable();

	self.navigate = function(model, event) {
		ahoy.track("$click", {
      panel: self.target,
      text: self.title
    });

		app.Display(self.target);
	}

	return this;
}