app.ViewModels.login = function(data, state) {
	var self = this;
	self.template = "login";
	self.username = ko.observable();
	self.password = ko.observable();
	self.reset_modal = ko.observable(false);
	self.error    = ko.observable();

	if(helper.platform() === "ios") {
		$('#statusBarColor').show();
	}

	self.submit = function() {
		helper.log('clicked');
		app.loading(true);

		$.ajax({
			'url': helper.apiEndpoint('login_form'),
			'type': 'post',
			'data': {
				'username': self.username(),
				'password': self.password(),
				'site_id': helper.site_id()
			},
			'success': function(ret) {
				if(ret.result === "success") {
					helper.log_in(ret.session_id, ret.username, ret.user_id, ret.signing_key);
					$('#statusBarColor').hide();
					app.Display('upcoming');
					app.State.header.seed(helper.site_blob());

					helper.getUserDetails();
					// app.State.user(new app.ViewModels.user(ret.user_details, state));
    			// app.State.uservisible(true);
				}
				else {
					app.loading(false);
					self.error(ret.message);
				}

			},
			'error': function(ret) {
				helper.log(ret);
			}
		});
	}


	self.toggle_reset_modal = function() {
		self.reset_modal(!self.reset_modal());
		helper.refreshScroll();
	}

	self.reset = function() {
		email = $('#email_password_reset').val();
		self.toggle_reset_modal();
		$('#email_password_reset').val('');

		app.State.overLoad(true);

		$.ajax({
			'url': helper.apiEndpoint('reset'),
			'type': 'post',
			'data': {
				'email': email,
			},
			'success': function(ret) {
				if(ret.result === "success") {
					helper.alertModal(ret.message);
				}
				else {
					app.loading(false);
					helper.alertModal(ret.message);
				}

			},
			'error': function(ret) {
				helper.log(ret);
			},
			'complete': function() {
				app.State.overLoad(false);
			}
		});

	}

	app.loading(false);
	return self;
}