app.ViewModels.navtemplate = function(data, state) {
var self = this;

    self.visible = ko.observable(false);
    self.navigation = ko.observable(false);
    self.buttons = ko.observableArray();

    self.activate_page = function(name) {
        ko.utils.arrayForEach(self.buttons(), function (button) {
            button.active(false);

            if(button.target == name) {
                button.active(true);
            }
        });
    }

    /**
     *  Load the footer with button data. Some day maybe this comes from a remote source.
     */
    data.buttons = [
        {
            'title': 'Activity',
            'target': 'activity'
        },
        {
            'title': 'Events',
            'target': 'upcoming'
        },
        {
            'title': 'Points',
            'target': 'points'
        },
        {
            'title': 'Prizes',
            'target': 'prizes'
        },
        {
            'title': 'Promos',
            'target': 'promos'
        }
    ];

    for(var i in data.buttons) {
        self.buttons.push(new app.ViewModels.nav_links(data.buttons[i], state));
    }


    // Seed the footer with needed data from the site_blob
    self.seed = function(data) {
        // helper.log(ad);
    }

    return self;
}

app.ViewModels.nav_links = function(data, state) {
    var self = this;

    self.title = data.title;
    self.target = data.target;
    self.active = ko.observable();

    self.navigate = function(model, event) {
        ahoy.track("$click", {
          panel: self.target,
          text: self.title
        });

        helper.log('navigate');
        app.Display(self.target);
    }

    return this;
}