app.ViewModels.picker = function(data, state) {
	var self = this;
	self.sites = ko.observableArray();
	self.selectedSite = ko.observable();
    self.template = "picker";
    self.loading = ko.observable(true);
    self.show_continue = ko.observable(false);

    self.loading.subscribe(function(status){
        if(status) {
            $("#selector").fadeOut('fast', function(){
                $("#loading").fadeIn('fast');
            });
        }
        else {
            $("#loading").fadeOut('fast', function(){
                $("#selector").fadeIn('fast');
            });
        }
    });

    self.selectedSite.subscribe(function(value){
        if(value !== "undefined") {
            self.show_continue(true);
        }
    });

    $("body").addClass("picker");

	/**
	 * A site has been selected! Let's get all the site info
	 * and trigger the next display, which is always authenticate
	 */
	self.setSite = function() {
        if(typeof self.selectedSite() == 'undefined') {
            return;
        }

		storage.set('site_id', self.selectedSite());
        self.loading(true);

		$.ajax({
            'url': helper.apiEndpoint('site_blob'),
            'dataType': 'json',
            'data': { 'site_id': storage.get('site_id') },
            'type': 'post',
            'success': function(blob) {
                helper.log(blob);

            	if(blob.status == "success") {
                    storage.blob.set('site_blob', blob);
                    app.do_site_setup(blob);

                    app.styles_ready(function() {
                        $("body").removeClass("picker");
                        app.Display("authenticate", blob);
                    }, blob);
            	}
            	else {
                    $("body").removeClass("picker");
            		app.Display("error_panel");
            	}
            },
            'error': function() {
                $("body").removeClass("picker");
                app.Display("error_panel");
            }
    	});
	}

    /**
     * Fetch a list of all sites and populate the self.sites array
     */
	$.ajax({
        'url': helper.apiEndpoint('sites_list'),
        'dataType': 'json',
        'success': function(data) {
            for(var i in data) {
            	self.sites.push({ "site_id": data[i].site_id, "title": data[i].title} );
            }

            app.loading(false);
            self.loading(false);
        },
        'error': function() {
            app.Display("error_panel");
        }
    });

    helper.kill_iscroll();

    return self;
}