app.ViewModels.points = function(data, state) {
	var self 		= this;

	self.template 	= "points";
	self.user 		= ko.observable();
	self.scorables 	= ko.observableArray();
	self.events = ko.observableArray();

	// self.user 		= ko.observable(new app.ViewModels.user({}, state));
	self.ad 		= ko.observable(app.State.ad);
	self.question = ko.observable(app.State.questionbar);
	self.alert = ko.observable(app.State.alertbar);

  helper.checkPermissions();

	self.shuffle = function(o){
  	for(var j, x, i = o.length; i; j = Math.floor(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
  	return o;
	}

  params = { 'order_direction': 'desc', 'order_by': 'points' };
  helper.requestData(self.template, false, params, 'admin', 2);

  app.loading(true);

	self.subscription = app.View[self.template].subscribe(function(points) {
    self.subscription.dispose();
		helper.getUserDetails();

    helper.log(points, 'POINTS AND STUFF');

    self.events([]);
		for(var i in points.data) {
			// self.scorables.push(new app.ViewModels.point_parent(points.points[i], state));
      self.events.push(new app.ViewModels.point_events(points.data[i], state));
		}

		helper.log(self.events(), 'Oppertunties');
		// self.shuffle(self.events());
		app.loading(false);

		helper.refreshScroll();
		setTimeout(function(){ helper.refreshScroll(); }, 4000);
  });

	// display the cache
  points = helper.get_view(self.template);
	if(points) { app.View[self.template](points); }

	return self;
}

app.ViewModels.point_parent = function(data, state) {
	var self 	= this;

	self.name 	= ko.observable(data.name);
	self.events = ko.observableArray();

	for(var i in data.events) {
		self.events.push(new app.ViewModels.point_events(data.events[i], state));
	}

	return self;
}

app.ViewModels.point_events = function(data, state) {
	var self 	 = this;

	self.points  = ko.observable(data.points);
	self.type 	 = ko.observable(data.type);
	self.subtype = ko.observable(data.subtype);
	self.message = ko.observable(data.message);
  self.icon = ko.observable(data.icon);

	self.css_classes = function() {
    if(typeof self.icon() !== "undefined" && self.icon() !== "") {
      return self.icon();
    }

    else {
      switch(self.type()) {
        case 'twitter':
          return 'fa-twitter';
          break;
        case 'facebook':
          return 'fa-facebook-square';
          break;
        case 'pinterest':
          return 'fa-pinterest';
          break;
        case 'instagram':
          return 'fa-instagram';
          break;
        case 'crowdcameo':
          return 'fa-camera-retro';
          break;
        case 'tumblr':
          return 'fa-tumblr-square';
          break;
        case 'mobile':
          return 'fa-mobile';
          break;
        default:
          return 'fa-trophy';
      }
    }
  }

	return self;
}