app.ViewModels.prizes = function(data, state) {
	var self = this;
	self.template = "prizes";

	// self.user = ko.observable(new app.ViewModels.user({}, state));
	self.ad   = ko.observable(app.State.ad);
	self.question = ko.observable(app.State.questionbar);
	self.alert = ko.observable(app.State.alertbar);

	self.auctions = ko.observable(false);
	self.contests = ko.observable(false);
	self.items = ko.observable(false);
  self.all = ko.computed(function(){ return (self.auctions() || self.contests()) });
  self.prizes = ko.observableArray();

	self.store_active = ko.observable(true);

  helper.checkPermissions();

  helper.refreshScroll();

  params = {};
  helper.requestData(self.template, false, params, 'admin', 2);

  app.loading(true);

  self.sortPrizes = function(direction) {
    direction = direction ? direction : 'desc';
    sorted = self.prizes().sort(function(a, b){
      if(a.points == "" || typeof a.points == 'undefined') { a.points = 0; }
      if(b.points == "" || typeof b.points == 'undefined') { b.points = 0; }

      return (direction == 'asc') ? a.points-b.points : b.points-a.points;
    });

    if(sorted.length) { self.prizes(sorted); }

    helper.refreshScroll();
  }

	self.subscription = app.View[self.template].subscribe(function(prizes) {
    self.subscription.dispose();
    helper.getUserDetails();

    helper.log(prizes, 'MAKE IT RAIN');

    // self.store_active(prizes.store_active);
    $('img').off('load').on('load', function(){
      $.doTimeout('myscrollrefresh', 800, function() {
        helper.refreshScroll();
      });
    });

    if(typeof prizes.data.auctions !== "undefined") {
      for(var i in prizes.data.auctions) {
        self.auctions(true);
        self.prizes.push(new app.ViewModels.prize_auction(prizes.data.auctions[i], state));
      }
    }
    if(typeof prizes.data.contests !== "undefined") {
      for(var i in prizes.data.contests) {
        self.contests(true);
        self.prizes.push(new app.ViewModels.prize_contest(prizes.data.contests[i], state));
      }
    }
    if(typeof prizes.data.items !== "undefined") {
      for(var i in prizes.data.items) {
        self.items(true);
        if(!prizes.data.items[i].is_digital_download && prizes.data.items[i].quantity > 0) {
          self.prizes.push(new app.ViewModels.prize_item(prizes.data.items[i], state));
        }
      }
    }

    self.sortPrizes();

    app.loading(false);
    setTimeout(function(){helper.refreshScroll()}, 4000);
  });

  // display the cache
  prizes = helper.get_view(self.template);
  if(prizes) { app.View[self.template](prizes); }

	self.thisIsTheEnd = function(date){
		if(date) {
			d = new Date(date);

			return "Ends " + self.getMonth(d) + " " + self.getDay(d) + " at " + self.getTime(d);
		}
		else { return false; }
	}

	self.getMonth = function(d) {
    var monthNames = ["January", "February", "March", "April", "May", "June",
      "July", "August", "September", "October", "November", "December"];

    return monthNames[d.getMonth()];
  }


  self.getDay = function(d) {
  	day = d.getDate();

  	switch(day) {
  		case 1:
  		case 21:
  		case 31:
  			day = day + "st";
  			break;
  		case 2:
  		case 22:
  			day = day + "nd";
  			break;
  		case 3:
  		case 23:
  			day = day + "rd";
  			break;
  		default:
  			day = day + "th";
  			break;
  	}

    return day;
  }


  self.getTime = function(d) {

    var hours = d.getHours() % 12 == 0 ? '12' : d.getHours() % 12;
    var minutes = d.getMinutes() < 10 ? '0'+d.getMinutes() : d.getMinutes();
    var timeOfDay = d.getHours() < 12 ? "AM" : "PM";

    return hours + ":" + minutes + " " + timeOfDay;
  }

  self.displayPrizeDetails = function(info) {
    app.Display('prize', info);
    return;
  }

  self.filter = function(datum, event) {
    target = $(event.currentTarget);
    bubble = target.find('span');
    type = target.data('type');

    if(bubble.hasClass('selected')) { return; }

    $('.prizes_sort_nav li span.selected').removeClass('selected ptext');
    bubble.addClass('selected ptext');

    $('.bottom-border').removeClass('bottom-border');

    switch(type) {
      case 'all':
        $('.auction').show();
        $('.contest').show();
        $('.item').show();
        break;
      case 'auctions':
        $('.auction').show();
        $('.contest').hide();
        $('.item').hide();
        $('.prize:visible:last .item-details-container').addClass('bottom-border');
        break;
      case 'contests':
        $('.auction').hide();
        $('.contest').show();
        $('.item').hide();
        $('.prize:visible:last .item-details-container').addClass('bottom-border');
        break;
    }

    helper.refreshScroll();
  }

  self.sort = function(datum, event) {
    target = $(event.target);
    direction = target.data('direction');

    $('.bottom-border').removeClass('bottom-border');

    switch(direction) {
      case 'desc':
        target.data('direction', 'asc');
        target.removeClass('fa-sort-amount-desc');
        target.addClass('fa-sort-amount-asc');
        self.sortPrizes('asc');
        break;
      case 'asc':
        target.data('direction', 'desc');
        target.addClass('fa-sort-amount-desc');
        target.removeClass('fa-sort-amount-asc');
        self.sortPrizes('desc');
        break;
    }

    $('.prize:visible:last .item-details-container').addClass('bottom-border');
  }

	return self;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// AUCTION TEMPLATE
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
app.ViewModels.prize_auction = function(data, state) {
	var self = this;

  self.templateType = 'prize_auction';
  data.subTemplate = 'auction_template';
  data.checkoutTemplate = 'auction_checkout';

  self.info = data;
	self.bid_history = data.bid_history;
	self.bid_increment = data.bid_increment;
	self.description = nl2br(data.description);
	self.ending_at = data.ending_at;
	self.high_bid = data.high_bid;
	self.id = data.id;
	self.images = data.images;
	self.pickup_enabled = data.pickup_enabled;
	self.points = (data.high_bid)
		? data.high_bid : data.starting_bid;
	self.shipping_enabled = data.shipping_enabled;
	self.starting_at = data.starting_at;
	self.starting_bid = data.starting_bid;
	self.subtitle = data.subtitle;
	self.terms_conditions = data.terms_conditions;
	self.title = data.title;

	self.show_more = ko.observable(false);

	self.price = function() {
		if(self.points == 0) {
			return "Free Entry";
		}

		var delineator = self.points == 1 ? " Point" : " Points";
		return helper.punctuate_number(self.points) + delineator;
	}

	return self;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CONTEST TEMPLATE
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
app.ViewModels.prize_contest = function(data, state) {
	var self = this;

  self.templateType = 'prize_contest';
  data.subTemplate = 'contest_template';
  data.checkoutTemplate = 'contest_checkout';

  self.info = data;
	self.description = nl2br(data.description);
	self.ending_at = data.ending_at;
	self.entry_points = data.entry_points;
  self.points = self.entry_points
	self.id = data.id;
	self.images = data.images;
	self.pickup_enabled = data.pickup_enabled;
	self.quantity = data.quantity;
	self.shipping_enabled = data.shipping_enabled;
	self.starting_at = data.starting_at;
	self.subtitle = data.subtitle;
	self.success_message = data.success_message;
	self.terms_conditions = data.terms_conditions;
  self.free_first_entry_enabled = data.free_first_entry_enabled;
  self.free_first_entry_mobile_app = data.free_first_entry_mobile_app;
  self.user_entered = data.user_entered;
	self.title = data.title;

  self.free_first_all = (self.free_first_entry_enabled && !self.free_first_entry_mobile_app && !self.user_entered && data.entry_points > 0);
  self.free_first_mobile = (self.free_first_entry_enabled && self.free_first_entry_mobile_app && !self.user_entered && data.entry_points > 0);

  self.free_first = self.free_first_all || self.free_first_mobile;

	self.show_more = ko.observable(false);

	self.price = function() {
		if(self.entry_points == 0) {
			return "Free Entry";
		}

		var delineator = self.entry_points == 1 ? " Point" : " Points";
		return helper.punctuate_number(self.entry_points) + delineator;
	}

	return self;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ITEM TEMPLATE
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
app.ViewModels.prize_item = function(data, state) {
	var self = this;

  self.templateType = 'prize_item';
  data.subTemplate = 'item_template';
  data.checkoutTemplate = 'item_checkout';

  self.info = data;
	self.cost_points = data.cost_points;
  self.points = self.cost_points;
	self.description = nl2br(data.description);
	self.id = data.id;
	self.images = data.images;
	self.is_digital_download = data.is_digital_download;
	self.is_unlock = data.is_unlock;
	self.item_options = data.item_options;

	self.pickup_enabled = data.pickup_enabled;
	self.position = data.position;

	self.quantity = data.quantity;
	self.redemption_limit = data.redemption_limit;

	self.shipping_cost_currency = data.shipping_cost_currency;
	self.shipping_cost_points = data.shipping_cost_points;
	self.shipping_cost_type = data.shipping_cost_type;
	self.shipping_enabled = data.shipping_enabled;

	self.subtitle = data.subtitle;
	self.title = data.title;

	self.price = function() {
		if(self.cost_points == 0) {
			return "No Points Required";
		}

    var delineator = self.cost_points == 1 ? " Point" : " Points";

    if(self.is_unlock) {
      if(app.State.user().lifetime_points() && helper.crossedThreshold(self.cost_points)) {
        return "Unlocked";
      }
      else{
        return "Unlock at " + helper.punctuate_number(self.cost_points) + delineator;
      }
    }

    return helper.punctuate_number(self.cost_points) + delineator;
	}

	return self;
}