app.ViewModels.questionbar = function() {
  var self = this;
  self.settings = ko.observable();

  self.caption = ko.computed(function() {
    var cap;

    if(typeof(self.settings()) !== 'undefined' && self.settings().QuestionBarCaption) { cap = self.settings().QuestionBarCaption; }

    return cap;
  }, self);

  self.button_text = ko.computed(function() {
    var txt;

    if(typeof(self.settings()) !== 'undefined' && self.settings().QuestionBarButtonText) { txt = self.settings().QuestionBarButtonText; }
    else { txt = "Answer a Single Survey Question for Points"; }

    var icon = "<i class='fa fa-check-square-o'></i> ";

    return icon.concat(txt);
  }, self);

  self.display_banner = ko.observable(false);
  self.survey = ko.observable(app.State.survey);
  self.modal = ko.observable(app.State.modal);

  self.displayBanner = function(settings){
    self.settings(settings);
    self.display_banner(true);
  }

  self.pop_modal = function(){
    self.display_banner(false);
    self.survey().updateQuestion(self.survey().question().id());
    // self.survey().display_question(true);
    self.modal().content(self.survey());
    self.modal().template('survey');
    self.modal().active(true);
  }

  return self;
}