app.ViewModels.settings = function(data, state) {
	var self = this;
	self.template = "settings";
	self.connections = ko.observableArray([]);
	// self.user = ko.observable(new app.ViewModels.user({}, state));
	self.question = ko.observable(app.State.questionbar);
	self.alert = ko.observable(app.State.alertbar);
	details = storage.blob.get('user_details');
	self.points_available = ko.observable(details.available_points);
	self.points_earned = ko.observable(details.points);
	self.points_spent = ko.observable(details.spent_points);

	self.change_password = function() {
		app.Display("change_password");
	}

	self.sign_out = function() {
		helper.sign_out();
	}

	self.checkQueue = function(){
		self.beaconQueue = storage.blob.get('beaconQueue').length
	}

	self.checkQueue();

	/**
	* Let's go get those settigns
	*/
	self.getSettings = function() {
		helper.log("OSU! let's get some settings!");
  	if(helper.requestProcessing(self.template) == "false" || helper.requestProcessing(self.template) == false) {
			$.ajax({
				url: helper.apiEndpoint("settings"),
				beforeSend: function(request) {
					app.State.overLoad(true);
					helper.setRequest(self.template, true);
				},
				success: function(ret) {
					helper.set_view(self.template, ret);
					app.View[self.template](ret);
				},
				error: function(ret) {
					app.Display("error_panel");
				},
				complete: function() {
					helper.setRequest(self.template, false);
					app.State.overLoad(false);
				}
			});
		}
	}

  self.getSettings();

  /**
	* Subscribe to the change of the settings view
	* @param {array} settings | an array of settings from cache or the ajax response.
	*/
  self.subscription = app.View[self.template].subscribe(function(settings) {
    self.subscription.dispose();
    helper.log(settings, 'SETTINGS');

    helper.facebookConnected(settings.user.fb_connected);
	  helper.facebookOauthLink(settings.user.fb_oauth_path);

    self.connections([]);

    var current;

    for(var i in settings.connections) {
			current = settings.connections[i];
			if(current.type === "oauth") {
				blacklist = ["Youtube"];
				if($.inArray(current.name, blacklist) == -1) {
					self.connections.push(new app.ViewModels.oauth_connection(current, state));
				}
			}
			else {
				self.connections.push(new app.ViewModels.form_connection(current, state));
			}
		}


    app.loading(false);
    helper.refreshScroll();
    setTimeout(function(){ helper.refreshScroll(); }, 1000);
  });

  // display the cache
  settings = helper.get_view(self.template);
  if(settings) { app.View[self.template](settings); }


	return self;
}

/**
 * @param  {[type]} data
 * @param  {[type]} state
 * @return {[type]}
 */
app.ViewModels.oauth_connection = function(data, state) {
	var self = this;

	self.name 		= ko.observable(data.name);
	self.oauth_path = ko.observable(data.oauth_path);
	self.connected 	= ko.observable(data.connected);
	self.template   = "oauth_connection";

	self.set_class = function() {
		return self.connected() ? "connected" : "";
	}

	self.connect = function() {
		blacklist = ["Ticketmaster", "Youtube"];
		if($.inArray(self.name(), blacklist) > -1){
			helper.alertModal('To connect your '+ self.name() +' account please visit this website on a desktop computer.');
		}
		else {
      var $self = $(this),
          path  = self.oauth_path(),
          browser;

      helper.oauth_connection_handler(path, $self, function(callback_data) {
          callback_data.connected(true);
      }, self);

      helper.refreshScroll();
    }
	}

	return self;
}

/**
 * @param  {[type]} data
 * @param  {[type]} state
 * @return {[type]}
 */
app.ViewModels.form_connection = function(data, state) {
	var self = this;

	self.name 		= ko.observable(data.name);
	self.connected 	= ko.observable(data.connected);
	self.tpl 		= ko.observable(data.tpl);
	self.template   = "form_connection";
	self.display_form = ko.observable(false);

	self.set_class = function() {
		return self.connected() ? "connected" : "";
	}

	// Handle submitting generic data to Rewards.
	self.connect = function(obj, evt) {
		self.display_form( ! self.display_form());

		// Generic ajax form handler.
	    $(evt.currentTarget.parentElement).find("form").on("submit", function(e){

	        var $this = $(this),
	            data  = $this.serializeObject(),
	            endpoint = $this.attr("action"),
	            message  = $this.find(".message");

	        e.preventDefault();

	        // Prevent multiple submits
	        if(window.form_being_submitted) {
	            return;
	        }
	        window.form_being_submitted = true;

	        message.hide();

	        $.ajax(
	            endpoint,
	            {
	                'type': 'POST',
	                'data': data,
	                'crossDomain': true,
	                'dataType': 'json',
	                'success': function(d) {
	                    window.form_being_submitted = false;

	                    message.html(d.message).show();

	                    if(typeof d.result !== 'undefined')
	                    {
	                        message
	                            .removeClass()
	                            .addClass("message")
	                            .addClass(d.result);
	                    }

	                    if(d.result == "success") {
	                    	self.connected(true);
	                    	self.display_form(false);
	                    }
	                    helper.log(d);
	                },
	                'error': function(det) {
	                    window.form_being_submitted = false;

	                    helper.log(det);
	                }
	            }
	        );
	    });

		helper.refreshScroll();
	}

	return self;
}