app.ViewModels.user = function(data, state) {
	var self = this;
	self.template = "userbar";

	self.avatar 		= ko.observable();
	self.display_name	= ko.observable();
	self.point_total 	= ko.observable();
  self.lifetime_points = ko.observable();
	self.display_panel  = ko.observable(false);
	self.token_refresh  = ko.observable(false);
	self.token_uri      = ko.observable(false);
	self.token_name     = ko.observable(false);
	self.name_type 			= ko.observable();
	self.target = ko.observable('settings');
	self.intv = undefined;

	self.navigate 		= function() {
		app.Display($(event.currentTarget).attr("href"));
	};

	self.refresh_token  = function(e) {
		helper.oauth_connection_handler(self.token_uri(), $(this), function(callback_data) {
			callback_data.token_refresh(false);
		}, self);

        helper.refreshScroll();
	}

	self.settings = function() {
		 ahoy.track("$click", {
        panel: self.target(),
        text: 'settings'
      });

      helper.log('navigate');
      app.Display(self.target());
	}

	if(!helper.display_avatar()){
		self.intv = setInterval(function(){
			var answer =  $('.avatar img').height() > 0 ? true : false;

			if(answer) {
				clearInterval(self.intv);
				self.intv = undefined;
				helper.display_avatar(true);
			}
		}, 1000);
	}

	self.connect = function() {
		if (!helper.facebookConnected() && helper.facebookOauthLink()) {
      var $self = $(this),
          path  = helper.facebookOauthLink(),
          browser;

      helper.oauth_connection_handler(path, $self, function(callback_data) {
          callback_data.connected(true);
          helper.getUserDetails(true);
      }, self);

      helper.refreshScroll();
    }
	}

	if(Object.keys(data).length !== 0) {
		self.point_total(data.available_points);
    self.lifetime_points(data.points);
		self.display_name(data.display_name);
		self.avatar(data.avatar);
		self.display_panel(data.display_panel);
		self.name_type(data.name_type);

		for(var i in data.tokens) {
			if(data.tokens[i].refresh) {
				self.token_refresh(true);
				self.token_uri(data.tokens[i].refresh);
				self.token_name(data.tokens[i].name);
				break;
			}
		}
	}

	return self;
}